<!DOCTYPE html>
<html>
<head>
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
	<title>Bootstrap-Flex</title>
</head>
<body>
	<div class="container-fluid text-center"> 
			<h1>Bootstrap Flex</h1>			
				<p>Use the d-flex class to create flex container and transform direct children into flex items.</p>


			<h2>Centering Elements</h2>
			<!-- d-flex will change the elemt into block-level container. It will make all the elements become "flexible" that allows them to occupy space enought content of an element and the same time will have the elements appear beside each other -->
			<!-- d-flex should be in the container -->
			<!-- justify-content-center it will horizontally center all child elements and it will only be accessible if the display value is flex-->
			<!-- align-items-center class will vertically center all the child elements, it will only be accessible if the display value is flex  -->
			<!-- flex-column will display elements on top of each other -->
			<!-- flex-column-reverse it will display elements vertically starting from the blast div -->
			<div style="height: 500px;"class="bg-dark p-3 d-flex justify-content-center align-items-center flex-column-reverse"> 
				<div class="h-25 p-3 bg-success col-2">Flex Item A</div>
				<div class="h-25 p-3 bg-warning col-2">Flex Item B</div>
				<div class="h-25 p-3 bg-danger col-2">Flex Item C</div>
			</div>

			<h2>Flex Row</h2>
			<!-- flex row changes how the elements display horizontally -->
			<div class="bg-dark p-3 d-flex flex-row">
				<div class=" p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>

			</div>

			<h2>Flex Row Reverse</h2>
			<div class="bg-dark p-3 d-flex flex-row-reverse">
				<div class=" p-3 bg-success">Flex Item A</div>
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>

			</div>

			<h2>Creating Space Between Elements</h2>
			<!-- d-md-flex class will apply flex values to the display properties on a medium size screen and higher -->

			<!-- justify content around gives space on the elements, it will only be accessible if the display value is flex, it centers elements horizontally while creating space between elements and borders of its parent container  -->
			<div class="bg-dark p-3 d-md-flex justify-content-around">
				<div class="p-3 bg-success col-md-2">Flex Item A</div>
				<div class="p-3 bg-warning col-md-2">Flex Item B</div>
				<div class="p-3 bg-danger col-md-2">Flex Item C</div>

			</div>

			<h2>Flexbox with Margin</h2>
			<div class="bg-dark p-3 d-flex">
				<!-- mr-auto/margin right auto will occupy the remaining width of its parent container pushing all the other elements inline -->
				<!-- can be used in nav bar -->
				<div class="p-3 bg-success mr-auto">Flex Item A</div>
				<div class="p-3 bg-warning ">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
				<div class="p-3 bg-primary">Flex Item D</div>
			</div>


			<h2>Nested Flex Elements </h2>
			<!-- grand child shoud have d-flex because it is only applied to direch child -->
			<div class="bg-dark p-3 d-md-flex">
				<div class="p-3 bg-success mr-auto">Flex Item A</div>
					<div class="d-md-flex justify-content-between w-50">
						<!-- justify-content-width should have width value -->
						<div class="p-3 bg-warning">Flex Item B</div>
						<div class="p-3 bg-danger
					">Flex Item C</div>
						<div class="p-3 bg-primary">Flex Item D</div>
					</div>
			</div>


		</div>












	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>